<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_specialty_license".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderSpecialtyLicense".
 *
 * Columns in table "provider_specialty_license" available as properties of the model,
 * followed by relations of table "provider_specialty_license" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property integer $sub_specialty_id
 * @property string $license_number
 * @property integer $state_id
 *
 * @property ProviderSpecialty $provider
 * @property ProviderSpecialty $subSpecialty
 * @property State $state
 */
abstract class BaseProviderSpecialtyLicense extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_specialty_license';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderSpecialtyLicense|ProviderSpecialtyLicenses', $n);
    }

    public static function representingColumn()
    {
        return 'license_number';
    }

    public function rules()
    {
        return array(
            array('provider_id, sub_specialty_id, license_number, state_id', 'required'),
            array('provider_id, sub_specialty_id, state_id', 'numerical', 'integerOnly' => true),
            array('license_number', 'length', 'max' => 20),
            array('id, provider_id, sub_specialty_id, license_number, state_id', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'provider' => array(self::BELONGS_TO, 'ProviderSpecialty', 'provider_id'),
            'subSpecialty' => array(self::BELONGS_TO, 'ProviderSpecialty', 'sub_specialty_id'),
            'state' => array(self::BELONGS_TO, 'State', 'state_id'),
        );
    }

    public function pivotModels()
    {
        return array();
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => null,
            'sub_specialty_id' => null,
            'license_number' => Yii::t('app', 'License Number'),
            'state_id' => null,
            'provider' => null,
            'subSpecialty' => null,
            'state' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('sub_specialty_id', $this->sub_specialty_id);
        $criteria->compare('license_number', $this->license_number, true);
        $criteria->compare('state_id', $this->state_id);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
